#include <opencv2/imgproc/imgproc_c.h>
#include <opencv2/highgui/highgui.hpp>

IplImage *image;
IplImage *edge;

float kernel[] = {
    0.0f,  1.0f, 0.0f,
    1.0f, -4.0f, 1.0f,
    0.0f,  1.0f, 0.0f
};

int main(int argc, char **argv) {
    image   = cvLoadImage("./images/rice.tif", 0);
    edge    = cvCreateImage(    cvSize(image->width, image->height),
                                IPL_DEPTH_8U,
                                1   );

    CvMat mat_kernel = cvMat(3, 3, CV_32FC1, kernel);

    cvFilter2D( image,
                edge,
                &mat_kernel,
                cvPoint(-1, -1) );

    cvNamedWindow("Edge", 1);

    cvShowImage("Edge", edge);
    cvShowImage("Fruits", image);
    cvWaitKey(0);
    cvDestroyWindow("Edge");
    cvDestroyWindow("Fruits");

    cvRelease((void **) &image);
    cvRelease((void **) &edge);

    return 0;
}
